<!--- begin start mode --->
<cfswitch expression="#ThisTag.ExecutionMode#">


	<cfcase value="start">
	
		<cfset variables.Error = "">
		<!--- must have a closing tag --->
		<cfif NOT ThisTag.HasEndTag>
			<cfset variables.Error = variables.Error & "<li>A closing tag for CF_COLOR_PICKER is needed</li>">
		</cfif>
		<cfif NOT StructKeyExists(attributes, "Name") OR NOT Len(attributes.Name)>
			<cfset variables.Error = variables.Error & "<li>The argument 'Name' cannot be left blank</li>">
		</cfif>
		<!--- print out the error messages --->
		<cfif Len(Trim(variables.Error))>
			<strong>The following Errors have been detected in CF_COLOR_PICKER</strong>
			<ol>
				<cfoutput>#variables.Error#</cfoutput>
			</ol>
			<cfexit>
		</cfif>
		
		<cfparam name="attributes.Name" type="string" default="color">
		<cfparam name="attributes.ImagesLocation" type="string" default="/images/color_picker/">
		
	</cfcase>
	
	
	<cfcase value="end">
	
		<!--- IDs to be used in the tag --->
		<cfparam name="variables.ColorPickerMainWrapper" type="string" default="ColorPicker">
		<cfparam name="variables.PaletteSelectList" type="string" default="pallete_color_picker">
		<cfparam name="variables.PaletteWebSafe" type="string" default="palette_websafe">
		<cfparam name="variables.PaletteSelectedColor" type="string" default="PaletteSelectedColor">
		<!--- /IDs to be used in the tag --->
		<cfif NOT StructKeyExists(request, "ColorPickerOutput")>
			<cfset _OutputColorPicker()>
			<cfset request.ColorPickerOutput = true>
		</cfif>

		<cfoutput>
			<input type="text" name="#attributes.Name#" id="#attributes.Name#" value="" maxlength="7" size="7"> 
			<a href="javascript:ShowColorPicker('#attributes.Name#')"><img src="#attributes.ImagesLocation#icon_colorpicker.gif" alt="Select color" border="0"></a> 
			<a href="javascript:ClearColorField('#attributes.Name#')"><img src="#attributes.ImagesLocation#icon_delete.gif" alt="Clear color" border="0"></a>
		</cfoutput>
	</cfcase>
	
	
</cfswitch>


<cffunction name="_OutputColorPicker" access="private" output="true">
	<cfset var lColors = "00,33,66,99,CC,FF">
	<cfset var aColors = ArrayNew(1)>
	<cfset var iMinColor = 0>
	<cfset var iMaxColor = 0>
	<cfset var cColor = "">
	
	<cfset aColors = ListToArray(lColors, ",")>
	<cfset iMinColor = 1>
	<cfset iMaxColor = ArrayLen(aColors)>
	
	<cfoutput>
	
		<script language="javascript">
			var cFieldOnFocus;

			function ShowColorPicker(cField) {
				cFieldOnFocus = cField;
				var elColorDiv = document.getElementById('#variables.ColorPickerMainWrapper#');
				elColorDiv.style.display = "inline";
				var elSelectedColorDiv = document.getElementById("#variables.PaletteSelectedColor#");
				elSelectedColorDiv.style.backgroundColor =  document.getElementById(cField).value;
			}
			
			function ClearColorField(cFieldName) {
				var elFieldToClear = document.getElementById(cFieldName);
				elFieldToClear.value = "";
			}
			
			function ReturnColorValue(cColor) {
				var elToFill = document.getElementById(cFieldOnFocus);
				elToFill.value = cColor;
				HideDiv('#variables.ColorPickerMainWrapper#');
				ShowDiv('#variables.PaletteWebSafe#');
				var elSelectedColorDiv = document.getElementById("#variables.PaletteSelectedColor#");
				 elSelectedColorDiv.style.backgroundColor = "";
			}
			
			function ShowDiv(cDiv) {
				var elDiv = document.getElementById(cDiv);
				elDiv.style.display = "inline";
			}
			
			function HideDiv(cDiv) {
				var elDiv = document.getElementById(cDiv);
				elDiv.style.display = "none";
			}
			
			function DisplaySelectedColor(cColor) {
				var elSelectedColorDiv = document.getElementById("#variables.PaletteSelectedColor#");
				 elSelectedColorDiv.style.backgroundColor = cColor;
			}
			
			function ClearSelectedColor() {
				var elSelectedColorDiv = document.getElementById("#variables.PaletteSelectedColor#");
				elSelectedColorDiv.style.backgroundColor = "";
			}
		</script>
		
		<div id="#variables.ColorPickerMainWrapper#" style="display:none; position:absolute; left:25%; top:30%; z-index:10; border:1px solid ##666">
			<div style="background-color:##CCC; padding:5px; text-align:right">
				<a href="javascript:HideDiv('#variables.ColorPickerMainWrapper#')"><img src="#attributes.ImagesLocation#icon_delete.gif" alt="Close" border="0"></a>
			</div>
			<div style="padding:5px">
				<div style="padding:0 0 5px 0">
					<button id="#variables.PaletteSelectedColor#" style="padding:0 20px">&nbsp;</button>
				</div>
				<div id="#variables.PaletteWebSafe#">
					<table border="0" cellspacing="1" cellpadding="0">
					<cfloop from="#iMinColor#" to="#iMaxColor#" index="iRed">
						<tr>
						<cfloop from="#iMinColor#" to="#iMaxColor#" index="iGreen">
							<cfloop from="#iMinColor#" to="#iMaxColor#" index="iBlue">
								<cfset cColor = "##" & aColors[iRed] & aColors[iGreen] & aColors[iBlue]>
								<td id="#cColor#" bgcolor="#cColor#" title="#cColor#" onClick="ReturnColorValue('#cColor#')" style="cursor:pointer" onMouseOver="DisplaySelectedColor('#cColor#')" onMouseOut="ClearSelectedColor()">&nbsp;&nbsp;&nbsp;</td>
							</cfloop>
						</cfloop>
						</tr>
					</cfloop>
					</table>
				</div>
			</div>
		</div>
	</cfoutput>
</cffunction>